/*****************************************************************************
         (c) Copyright Effice Mrnki Iroda Kft. 1999.


Ez az llomny kizrolag a Effice Kft. (2083 Solymr Toldi u. 21.) tulajdona,
kizrolag csak az Effice Kft. engedlyvel, az engedlyben meghatrozott clra
s mdon hasznlhat fel.


  Field code definitions.
*****************************************************************************/

#ifndef __FIELDS__

/*+ Code for not defined value +*/
#define NOT_DEFINED                    -1

/*+ Code for make difference between MMTSI and MMTSII system +*/
#define MMTS_TYPE_1	1
#define MMTS_TYPE_2	2

/*+ Code for state of PGW process +*/
#define PGWINITED                       2       /*+ Pgw process inited, download of static data are starting. +*/
#define PGWRUNNING                      0       /*+ Pgw process downloaded every static data, and fress dynamic data. +*/
#define PGWTERMINATED                   1       /*+ Pgw process terminated. +*/

#define BOARDID_LEN                     4       /*+ Length of board identifyer +*/
#define SECID_1_LEN                    12       /*+ Length of security identifyer of MMTS I. +*/
#define SECID_2_LEN                    20       /*+ Length of security identifyer of MMTS II. +*/

/*+ struct for fixed real of MMTSII +*/
struct fix_real
  {
     double value;
     int decimals; 
  };

typedef struct fix_real fixReal;

/*+ struct for datetime of MMTSII +*/
struct date_time
  {
     int time;
     int date;
  };

typedef struct date_time dateTime;

/*+ struct for a precise datetime in MMTSII +*/
struct date_time_msec
{
	int time;
	int date;
	int millisec;
};

typedef struct date_time_msec dateTimeMsec;

/*+ codes of BUYSELL flag +*/
enum BUYSELLVERB {
  BuySellVerb_Buy = 0,
  BuySellVerb_Sell = 1,
  BuySellVerb_BuyOrSell = 2
};

/*+ codes of ordertype field +*/
enum ORDERTYPE {
  OrderType_Limit = 0,
  OrderType_Market = 1
};

/*+ codes of duration field +*/
enum DURATION {
  Duration_Immediate = 1,
  Duration_Session = 2,
  Duration_Day = 3,
  Duration_GoodTillDate = 4,
  Duration_GoodTillTime = 5,
  Duration_GoodTillCancelled = 6
};

/*+ codes of bool of MMTSII +*/
enum MMTS_BOOL {
  MMTS_False = 0,
  MMTS_True = 1
};

/*+ codes of position type field +*/
enum POSITIONTYPE {
  PositionType_OpeningTrade = 0,
  PositionType_ClosingTrade = 1,
  PositionType_DayTrade = 2
};

/*+ codes of boolop fields of order withdraw +*/
enum BOOLOP {
  BoolOp_And = 0,
  BoolOp_Or = 1,
  BoolOp_Not = 2
};

/*+ codes of compareop fields of order withdraw +*/
enum COMPAREOP {
  CompareOp_EQ = 0,
  CompareOp_NT = 1,
  CompareOp_GT = 2,
  CompareOp_GE = 3,
  CompareOp_LT = 4,
  CompareOp_LE = 5 
};

/*+ codes of status fields +*/
enum STATUS {
  Status_Active = 0,
  Status_Suspended = 1
};

/*+ codes of secclassid fields +*/
enum SECCLASSID {
  SecClassId_Index = 1,
  SecClassId_Spread = 2,
  SecClassId_MultiLeg = 3,
  SecClassId_Debt = 4,
  SecClassId_Equity = 5,
  SecClassId_Future = 6,
  SecClassId_Option = 7,
  SecClassId_Commodity = 8
};

/*+ codes of negdeal initatior field +*/
enum NegDealInit {
  NegDealInit_Buy = 0,
  NegDealInit_Sell = 1,
  NegDealInit_Either = 2
};

/*+ codes of optionverb flag +*/
enum OptionVerb {
  OptionVerb_Put = 1,
  OptionVerb_Call = 2
};

/*+ codes of settlementprice type field +*/
enum SettlementPriceType {
  SettlementPriceType_Indicative = 0,
  SettlementPriceType_IntraDay = 1,
  SettlementPriceType_EndOfDay = 2,
  SettlementPriceType_Final = 3,
};

/*+ codes of firm class fields +*/
enum FirmClass {
  FirmClass_Broker = 0,
  FirmClass_Issuer = 1,
  FirmClass_Institution = 2,
  FirmClass_Exchange = 3,
  FirmClass_Other = 4
};

/*+ codes of closeout status field +*/
enum CloseOutStatus {
  CloseOutStatus_CloseOut = 1,
  CloseOutStatus_None = 2 
};

/*+ codes of orderstatus field +*/
enum OrderStatus {
  OrderStatus_OPEN = 1,
  OrderStatus_AMENDED = 2,
  OrderStatus_MATCHED = 3,
  OrderStatus_WITHDRAW = 4,
  OrderStatus_UNCOMFIRMED = 5,
  OrderStatus_UNAPPROVED = 6, 
  OrderStatus_EXPIRED = 7, 
  OrderStatus_INACTIVESTOP = 8,
  OrderStatus_UNPLACEDSTOP = 9,
  OrderStatus_UNPLACED = 10,
  OrderStatus_EMBARGOED = 11,
  OrderStatus_PRIVATEORDER = 12
};

/*+ codes of filltype field of orderentry +*/
enum FILLTYPE {
  FillType_FillAny = 0,
  FillType_FillMinQty = 1,
  FillType_FillOrNone = 2 
};

/*+ codes of trade status +*/
enum TRADESTATUS {
  TradeStatus_Matched = 1,
  TradeStatus_WithDrawn = 2,
  TradeStatus_Unapproved = 3,
  TradeStatus_Unconfirmed_buy = 4,
  TradeStatus_Unconfirmed_sell = 5
};

/*+ codes of dissemanation status field +*/
enum DissemStatus {
  DissemStatus_NotMatched = 1,
  DissemStatus_NoDelay = 2,
  DissemStatus_Delayed = 3,
  DissemStatus_Sent = 4,
  DissemStatus_Released = 5,
  DissemStatus_Lapsed = 6
};

/*+ codes of fields of secboard to sign change of that +*/
enum SBSEQARRAYIDX {
   SA_SB_REMARKS,
   SA_SB_STATUS,
   SA_SB_BIDPRICE,
   SA_SB_BIDDEPTH,
   SA_SB_BIDDEPTHT,
   SA_SB_BIDN,
   SA_SB_OFFERPRICE,
   SA_SB_OFFERDEPTH,
   SA_SB_OFFERDEPTHT,
   SA_SB_OFFERN,
   SA_SB_OPENPRICE,
   SA_SB_HIGHPRICE,
   SA_SB_LOWPRICE,
   SA_SB_LASTPRICE,
   SA_SB_LASTOFFMKTPRICE,
   SA_SB_CHANGEPRICE,
   SA_SB_QUANTITY,
   SA_SB_TIME,
   SA_SB_VOLTODAY,
   SA_SB_VALTODAY,
   SA_SB_ORDERMETHODS,
   SA_SB_CHANGELTP,
   SA_SB_CHANGELTY,
   SA_SB_PREVDATE,
   SA_SB_PREVPRICE,
   SA_SB_LASTOFFMKTYIELD,
   SA_SB_SESSION,
   SA_SB_VALUE,
   SA_SB_LASTYIELD,
   SA_SB_QTYOFFMKT,
   SA_SB_REFPRICE,
   SA_SB_VOLTRADED,
   SA_SB_VALTRADED,
   SA_SB_NUMTRADES,
   SA_SB_NUMORDERS,
   SA_SB_CHANGEPRICEPCT,
   SA_SB_OPENORDERS,
   SA_SB_WAPRICE,
   SA_SB_EPS,
   SA_SB_NEGDEALINIT,
   SA_SB_SUSPDATE,
   SA_SB_SUSPTIME,
   SA_SB_ANNOUNCE,
   SA_SB_UPPERPRICELIMIT,
   SA_SB_LOWERPRICELIMIT,
   SA_SB_CBLIMITUPPER,
   SA_SB_CBLIMITLOWER,
   SA_SB_BIDYIELD,
   SA_SB_OFFERYIELD,
   SA_SB_CLOSEPRICE,
   SA_SB_VOLOFFMKTTODAY,
   SA_SB_VALOFFMKTTODAY,
   SA_SB_VOLOFFMKTTRADED,
   SA_SB_VALOFFMKTTRADED,
   SA_SB_OPENYIELD,
   SA_SB_HIGHYIELD,
   SA_SB_LOWYIELD,
   SA_SB_CLOSEYIELD,
   SA_SB_REFYIELD,
   SA_SB_CHANGEYIELD,
   SA_SB_WAYIELD,
/* #ifdef BSE_PRIVATEOB */
   SA_SB_PRIVATEOB,
/* #endif */
   SA_SB_ACCRUEDINTEREST,
   SA_SB_CBREFPRICE,
   SA_SB_CBREFYIELD,
   SA_SB_CHANGEOPENINT,
   SA_SB_CHANGESTATETIME,
   SA_SB_FIXINGPRICE,
   SA_SB_IMPLIEDBIDDEPTH,
   SA_SB_IMPLIEDOFFERDEPTH,
   SA_SB_INDICATIVEPRICE,
   SA_SB_INDICATIVEYIELD,
   SA_SB_INHERITEDSTATUS,
   SA_SB_ISACTIVE,
   SA_SB_LASTQTY,
   SA_SB_MARKETCAP,
   SA_SB_OPENINTEREST,
   SA_SB_PREVYIELD,
   SA_SB_QUOTEBASES,
   SA_SB_SETTLEPRICE,
   SA_SB_SETTLEPRICEIND,
   SA_SB_SETTLEPRICETYPE,
   SA_SB_STRIKEVALUETODAY,
   SA_SB_TRADEDATE,
   SA_SB_UNDERLYINGLASTPRICE,
   SA_SB_VOLATILITY,
   SA_SB_LAST, /* ~always~ last! */
};

/*+ enum codes of filltype field of auditevent towhat and towhom +*/
enum EntityToWhatToWhom {
	Entity_NONE = 0,
	Entity_BOARD = 1,
	Entity_SECURITY = 2,
	Entity_SECBOARD = 3,
	Entity_TRADE = 4,
	Entity_ORDER = 5,
	Entity_USER = 6,
	Entity_FIRM = 7,
	Entity_INSTRUMENT = 8
};

/*+ enum codes of auditevent displaymode +*/
enum DispMode {
  DisplayMode_NODISPLAY = 0,
  DisplayMode_STATUSLINE = 1,
  DisplayMode_POPUP = 2
};


#define __FIELDS__  /*+ To stop multiple inclusions. +*/
#endif

